/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and others contributors as indicated
 * by the @authors tag. All rights reserved.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
package org.jboss.soa.esb.samples.quickstart.helloworld;

import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;
import java.text.SimpleDateFormat;


public class MyJMSListenerAction extends AbstractActionLifecycle
{

	protected ConfigTree	_config;
	private int 			_i;

	public MyJMSListenerAction(ConfigTree config) { _config = config; }

	private String now(String dateFormat) {
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
		return sdf.format(cal.getTime());
	}

	private void dowork(int ms) throws Exception
	{
		Date date = new Date();
		long start = date.getTime();
		while (true)
		{
			Thread.sleep(1);
			date = new Date();
			long now = date.getTime();
			if (now-start > ms) {
				break;
			}
			_i++;
		}
	}

	public Message displayMessage(Message message)  throws Exception{
		String body="";
		if (message.getBody()!=null && message.getBody().get()!=null)
			body = (String)message.getBody().get();

		if (body.indexOf("$50$")>0)
			dowork(50);
		if (body.indexOf("$100$")>0)
			dowork(100);
		if (body.indexOf("$250$")>0)
			dowork(250);
		if (body.indexOf("$500$")>0)
			dowork(500);
		if (body.indexOf("$1000$")>0)
			dowork(1000);

		int len = body.length();
		int index=body.indexOf("~");  // If you want to pass arbitrary data and don't want it to print include a ~
		if (index>0)
			body=body.substring(0, index-1);

		String results = body + "," + java.lang.Thread.currentThread().getId() + "," + len + "," + now("hh:mm:ss.SSSSSS");
		System.out.println(results);

		return message;
	}

}